-- Copyright (C) 2015 Tomoyuki Fujimori <moyu@dromozoa.com>
--
-- This file is part of dromozoa-commons.
--
-- dromozoa-commons is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- dromozoa-commons is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with dromozoa-commons.  If not, see <http://www.gnu.org/licenses/>.

local escape_char = {
  [string.char(0x26)] = "&amp;";
  [string.char(0x3C)] = "&lt;";
  [string.char(0x3E)] = "&gt;";
  [string.char(0x22)] = "&quot;";
  [string.char(0x27)] = "&apos;";
}

local function escape(value)
  return (tostring(value):gsub("[&<>\"']", escape_char))
end

return {
  escape = escape;
}
